/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/* locus_peel.h:  Header file that brings in all functions that are */
/*                specific to peeling a single locus.               */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

int code_dna(int, int, int);            /* Converts genos to int codes    */

void uncode_dna(int, int*, int*, int);  /* Convert integer codes to genos */

double sege(int, int, int, int);        /* Computes parent-offspring segs */

double pene(int g, int y, double, int); /* Computes the P(y|g,epsilon)    */

double locus_peel( int, double, int, int*, int, int***, int*, double**, 
                   double*** );
                                        /* Peels a locus and/or samples
                                           the genos at that locus        */

