/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/* function to generate permutations from a list */

int rand_permutation (int NO_ITER, int *Total_Size, char *permutationFile,
                      char *observedFile)
{
   int   iter1 = 0;
   int   tag = 0;
   int   countnew = 0;
   int   elementExists = 0;
   int   randomNumber = 0;
   int   i, j, k, l, m1, v1, t1, sum1 = 0;
   int ***GroupElements = NULL;
   FILE *fp3 = NULL;
   FILE *fp1 = NULL;

   if ((observedFile == NULL))
   {
      printf ("Invalid input file for observed \n");
      return 0;
   }
   if ((permutationFile == NULL) && (NO_ITER == 1))
   {
      printf ("Don't you want to permute?\n");
   }
   else if ((permutationFile == NULL) && (NO_ITER > 1))
   {
      printf ("Invalid input file for observed \n");
      return 0;
   }

   fp3 = open_chkq (WHERE, observedFile, "r");

   if (NO_ITER > 1)
   {
      fp1 = open_chkq (WHERE, permutationFile, "r");

   }

   matry = (int ***) calloc (n_compnts, sizeof (int **));
   alloc_chk (WHERE, matry);

   for (k = 0; k < n_compnts; k++)
   {
      matry[k] = (int **) calloc (NO_ITER, sizeof (int *));
      alloc_chk (WHERE, matry[k]);

      for (i = 0; i < NO_ITER; i++)
      {
         matry[k][i] = (int *) calloc (Total_Size[k], sizeof (int));
         alloc_chk (WHERE, matry[k][i]);
      }
   }

   GroupElements = (int ***) calloc (n_compnts, sizeof (int **));
   alloc_chk (WHERE, GroupElements);

   for (k = 0; k < n_compnts; k++)
   {
      if (Group[k] > 0)
      {
         GroupElements[k] = (int **) calloc (Group[k], sizeof (int *));
         alloc_chk (WHERE, GroupElements[k]);

         for (i = 0; i < Group[k]; i++)
         {
            GroupElements[k][i] = (int *) calloc ((Size[k][i]), sizeof (int));
            alloc_chk (WHERE, GroupElements[k][i]);
         }
      }
      else
      {
         GroupElements[k] = NULL;
      }
   }

   tag = 0;
   for (k = 0; k < n_compnts; k++)
   {
      if (Group[k] > 0)
      {
         for (i = 0; i < Group[k]; i++)
         {
            for (j = 0; j < (size_aff[k][i] + size_unaff[k][i]); j++)
            {
               if ((j == (size_aff[k][i] + size_unaff[k][i] - 1))
                   && (i == Group[k] - 1))
               {
                  if ((fscanf (fp1, "%d \n", &GroupElements[k][i][j])) == EOF)
                  {
                     printf ("EOF readhed in perm line at (%d)\n", __LINE__);
                     tag = 1;
                     break;
                  }
                  break;
               }

               else if ((fscanf (fp1, "%d ", &GroupElements[k][i][j])) == EOF)
               {
                  printf ("EOF readhed in perm line at (%d)\n", __LINE__);
                  tag = 1;
                  break;
               }
            }
            if (tag == 1)
               break;
         }
      }
   }

   for (k = 0; k < n_compnts; k++)
   {
      tag = 0;
      iter1 = 0;
      while (iter1 < NO_ITER)
      {
         if (iter1 == 0)
         {
            if (Group[k] > 0)
            {
               int   sum = 0;
               for (i = 0; i < Group[k]; i++)
               {
                  for (j = 0; j < size_aff[k][i]; j++)
                  {
                     if (fscanf (fp3, "%d  ", &matry[k][iter1][sum]) == EOF)
                     {
                        tag = 1;
                        break;
                     }
                     sum = sum + 1;
                  }
               }
               for (i = 0; i < Group[k]; i++)
               {
                  for (j = 0; j < size_unaff[k][i]; j++)
                  {
                     if (sum == (Total_Size[k] - 1))
                     {
                        if (fscanf (fp3, "%d  \n", &matry[k][iter1][sum]) ==
                            EOF)
                        {
                           tag = 1;
                           break;
                        }
                        tag = 1;
                        break;
                     }
                     else
                     {
                        if (fscanf (fp3, "%d  ", &matry[k][iter1][sum]) == EOF)
                        {
                           tag = 1;
                           break;
                        }
                        sum = sum + 1;
                     }
                  }
                  if (tag == 1)
                  {
                     break;
                  }
               }
            }

         }
         else
         {
            if (Group[k] > 0)
            {
               int   sum = 0;
               for (i = 0; i < Group[k]; i++)
               {
                  int  *samples = (int *) calloc (size_aff[k][i], sizeof (int));
                  alloc_chk (WHERE, samples);

                  for (l = 0; l < size_aff[k][i]; l++)
                  {
                     samples[l] = -1;
                  }

                  countnew = 0;
                  while (countnew < size_aff[k][i])
                  {
                     unsigned int val_ran = (unsigned int) lran ();
                     randomNumber = val_ran % Size[k][i];
                     elementExists = 0;
                     for (l = 0; l < size_aff[k][i]; l++)
                     {
                        if (GroupElements[k][i][randomNumber] == samples[l])
                        {
                           elementExists = 1;
                           break;
                        }
                     }
                     if (elementExists == 0)
                     {
                        samples[countnew] = GroupElements[k][i][randomNumber];
                        matry[k][iter1][sum] = samples[countnew];
                        /*  create the samples */
                        countnew = countnew + 1;
                        sum = sum + 1;
                     }
                  }
                  free (samples);
                  samples = NULL;
               }

               sum1 = 0;
               for (i = 0; i < Group[k]; i++)
               {
                  /** from here ****/
                  t1 = size_aff[k][i];
                  while (t1 < Size[k][i])
                  {
                     for (v1 = 0; v1 < Size[k][i]; v1++)
                     {
                        tag = 0;
                        for (m1 = 0; m1 < (size_aff[k][i]); m1++)
                        {
                           if (GroupElements[k][i][v1] ==
                               matry[k][iter1][m1 + sum1])
                           {
                              tag = 1;
                              break;
                           }
                        }
                        if (tag == 0)
                        {
                           /*  create the samples */
                           matry[k][iter1][sum] = GroupElements[k][i][v1];

                           t1 = t1 + 1;
                           sum = sum + 1;
                        }
                     }

                  }
                  /* end here */
                  sum1 = sum1 + size_aff[k][i];
               }
            }
         }
         iter1 = iter1 + 1;
      }
   }
   for (k = 0; k < n_compnts; k++)
   {
      if (Group[k] > 0)
      {
         for (i = 0; i < Group[k]; i++)
         {
            free (GroupElements[k][i]);
         }
      }
      if (GroupElements[k])
         free (GroupElements[k]);
   }
   if (GroupElements)
      free (GroupElements);
   if (fp1)
      fclose (fp1);
   if (fp3)
      fclose (fp3);

   return 1;
}
