/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* rs.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int rs_ (nm, n, a, w, matz, z__, fv1, fv2, ierr)
     integer *nm, *n;
     doublereal *a, *w;
     integer *matz;
     doublereal *z__, *fv1, *fv2;
     integer *ierr;
{
   /* System generated locals */
   integer a_dim1, a_offset, z_dim1, z_offset;

   /* Local variables */
   extern /* Subroutine */ int tred1_ (), tred2_ (), tqlrat_ (), tql2_ ();

/* ***BEGIN PROLOGUE  RS */
/* ***DATE WRITTEN   760101   (YYMMDD) */
/* ***REVISION DATE  830518   (YYMMDD) */
/* ***CATEGORY NO.  D4A1 */
/* ***KEYWORDS  EIGENVALUES,EIGENVECTORS,EISPACK */
/* ***AUTHOR  SMITH, B. T., ET AL. */
/* ***PURPOSE  Computes eigenvalues and, optionally, eigenvectors of */
/*            DOUBLE PRECISION symmetric matrix. */
/* ***DESCRIPTION */

/*     This subroutine calls the recommended sequence of */
/*     subroutines from the eigensystem subroutine package (EISPACK) */
/*     to find the eigenvalues and eigenvectors (if desired) */
/*     of a DOUBLE PRECISION SYMMETRIC matrix. */

/*     On Input */

/*        NM  must be set to the row dimension of the two-dimensional */
/*        array parameters as declared in the calling program */
/*        dimension statement. */

/*        N  is the order of the matrix  A. */

/*        A  contains the DOUBLE PRECISION symmetric matrix. */

/*        MATZ  is an integer variable set equal to zero if */
/*        only eigenvalues are desired.  Otherwise it is set to */
/*        any non-zero integer for both eigenvalues and eigenvectors. */

/*     On Output */

/*        W  contains the eigenvalues in ascending order. */

/*        Z  contains the eigenvectors if MATZ is not zero. */

/*        IERR  is an integer output variable set equal to an */
/*        error completion code described in section 2B of the */
/*        documentation.  The normal completion code is zero. */

/*        FV1  and  FV2  are temporary storage arrays. */

/*     Questions and comments should be directed to B. S. Garbow, */
/*     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY */
/*     ------------------------------------------------------------------ */
/* ***REFERENCES  B. T. SMITH, J. M. BOYLE, J. J. DONGARRA, B. S. GARBOW, */
/*                 Y. IKEBE, V. C. KLEMA, C. B. MOLER, *MATRIX EIGEN- */
/*                 SYSTEM ROUTINES - EISPACK GUIDE*, SPRINGER-VERLAG, */
/*                 1976. */
/* ***ROUTINES CALLED  TQL2,TQLRAT,TRED1,TRED2 */
/* ***END PROLOGUE  RS */

/* ***FIRST EXECUTABLE STATEMENT  RS */
   /* Parameter adjustments */
   --fv2;
   --fv1;
   z_dim1 = *nm;
   z_offset = z_dim1 + 1;
   z__ -= z_offset;
   --w;
   a_dim1 = *nm;
   a_offset = a_dim1 + 1;
   a -= a_offset;

   /* Function Body */
   if (*n <= *nm)
   {
      goto L10;
   }
   *ierr = *n * 10;
   goto L50;

 L10:
   if (*matz != 0)
   {
      goto L20;
   }
/*     .......... FIND EIGENVALUES ONLY .......... */
   tred1_ (nm, n, &a[a_offset], &w[1], &fv1[1], &fv2[1]);
   tqlrat_ (n, &w[1], &fv2[1], ierr);
   goto L50;
/*     .......... FIND BOTH EIGENVALUES AND EIGENVECTORS .......... */
 L20:
   tred2_ (nm, n, &a[a_offset], &w[1], &fv1[1], &z__[z_offset]);
   tql2_ (nm, n, &w[1], &fv1[1], &z__[z_offset], ierr);
 L50:
   return 0;
}                                       /* rs_ */
