/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/******************************************************************************/
/*                                                                            */
/*       parsie.h:  Header file for the Pars library.                         */
/*                  This header file is included by Pars functions and by     */
/*                  main Morgan programs calling Pars functions.              */
/*                                                                            */
/******************************************************************************/

#ifndef  PARSIE_H
#define  PARSIE_H
#include "incs.h"
#include "stuff.h"

/******        Function prototypes for main Pars functions.              ******/

/**
 * @addtogroup parse
 * @{
 */

int  check_pars   (int, int);
int  input_eigen  (int);
int  proc_pars    (int, char **, char *);
int  proc_auto    (void);
int  proc_lods    (void);
int  proc_ibd     (void);
int  proc_kin     (void);
int  proc_drop    (void);
int  proc_err     (void);
int  proc_poly    (void);
int  proc_disp    (void);
int  proc_seeds   (void);
int  proc_fils    (void);
int  proc_free    (void);
int  proc_end     (void);

int  tok2int      (char *, int *);
int  tok2real     (char *, double *);
int  test_indfil  (void);
void alloc_sel    (void);

void  procParStat     (int, char **, char *);
void  procParIndivs   (int, char **, char *);
void  setupBasic      (char *, int, char **, char *);
void  init_rans_seeds (void);
int   test_auto_pars  (void);

/** @} */
#endif  /*PARSIE_H*/
