/******************************************************************************/
/*                                                                            */
/* This file contains various debugging subroutines written to be called by   */
/* gl_lods.                                                                   */
/*                                                                            */
/******************************************************************************/

#include "lodscore.h"

/******************************************************************************/
/*                                                                            */
/* Debugging subroutine called to output gl_lods input trait data along with  */
/* requested marker numbers and whether or not individuals are observed.      */
/*                                                                            */
/******************************************************************************/

void lods_prnt_trait_data (void)
{
   long  mark_ndx;                      /* Current marker subscript.          */

   int   ped_ndx;                       /* Pedigree subscript into nghd[].    */

   /*  Check the requested markers.                                           */

   printf (" %d Requested markers:\n", NMarks);
   for (mark_ndx = 0; mark_ndx < NMarks; ++mark_ndx)
      printf ("  %d", MarLod[mark_ndx]);

   printf ("\n\n");
   fflush (stdout);

   /*  Check the data file input.                                             */

   for (ped_ndx = 0; ped_ndx < pedsize; ++ped_ndx)
   {
      printf ("  %s  %d  ", nghd[ped_ndx].self, nghd[ped_ndx].obs);
      if (!nghd[ped_ndx].obs)
         printf ("  N/A\n");
      else
      {
         if (TraitTyp == QUANTITATIVE)
            printf (" %f\n", nghd[ped_ndx].q_dat[0]);
         if (TraitTyp == DISCRETE)
            printf (" %d\n", nghd[ped_ndx].d_dat[0]);
      }
   }

   printf ("\n\n");

   return;
}
