/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

#include "nghds.h"

/* Allocates data, nghds and cmplist data structures.                         */

void alloc_ped (void)
{
   int   i;

   data = (int **) malloc ((PedSize) * sizeof (int *));
   alloc_chk (WHERE, data);
   data[0] = (int *) malloc ((PedSize) * NColData * sizeof (int));
   alloc_chk (WHERE, data[0]);

   for (i = 1; i < PedSize; ++i)
      data[i] = data[i - 1] + NColData;

   nghd = (Ind *) malloc ((PedSize + 1) * sizeof (Ind));
   alloc_chk (WHERE, nghd);

/* Initialize meiosis indices.                                                */

   for (i = 0; i < PedSize; ++i)
   {
      nghd[i].patmeio = 0;
      nghd[i].matmeio = 0;
      nghd[i].nkidmeio = 0;
      nghd[i].kidmeio = NULL;
   }

/* Initialize pointers to observed marker and trait data.                     */

   for (i = 0; i < PedSize; ++i)
   {
      nghd[i].d_dat = NULL;
      nghd[i].q_dat = NULL;
      nghd[i].g_dat = NULL;
      nghd[i].obs = 0;
   }

   cmplist = (Component *) malloc ((nCompnt + 1) * sizeof (Component));
   alloc_chk (WHERE, cmplist);

   return;
}

/* ------- free_ped:  Frees the arrays allocated by alloc_ped,       -------- */
/*                    with the exception of the nghd and cmplist arrays.      */
/*                    It also frees SelInt and SelReal.                       */

void free_ped (void)
{
   free_2d ((void *) &data);
   free_1d ((void *) &SelInt);
   free_1d ((void *) &SelReal);

   return;
}
