/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* -------------check_pars:  called by PolyEM programs -------------------

 * check_pars compares the number of starting values for fixed effect levels
 * against the number of levels found by sortdat after the pedigree file is
 * read.
 *                                                            MAJ Jun 1997
 */
int check_pars (int np, int max_cpsiz)
{
   int   entry, effno, x1;
   TRAITEFF_PTR p_te;
   FIXEDEFF_PTR p_fe;

   for (x1 = 1; x1 <= NFix; ++x1)       /* Compares number of levels of fixed */
      if (IFix[x1] > LEVELS)            /* effects to number allowed.         */
         err_typ = ERR_FFL;

   if (!err_typ)                        /* Compares number of starting values */
/*                                     to number of levels found in pedigree. */
   {
      entry = FALSE;
      while ((p_te = nxt_tr_eff (&entry)))
      {
         if (SelReal[p_te->trait_num - 1]) /* If trait has been selected:     */
         {
/* If a "set trait K1 effects X1 X2 ..." statement was given by user:         */
            if (p_te->set_trait_eff_inp)
            {

/* For each "start trait K1 effects X1 X2 ..." statement given by user:       */
               p_fe = p_te->p_eff_list;

               while (p_fe)
               {
                  effno = p_fe->eff_num;
                  for (x1 = 0; x1 < p_te->num_eff; ++x1)
                  {
                     if (effno == p_te->eff_nums[x1])
                     {
                        if (p_fe->nstartff != IFix[cum_selff[effno - 1]])
                           err_typ = ERR_FFN;
                     }
                  }
                  p_fe = p_fe->p_next;
               }
            }
         }
      }
   }

   free_poly_arrays ();                 /* Frees arrays used by proc_poly.    */

   if (ICh == 1)                        /* If eigenvalues are to be computed, */
      if (!UNIVAR)                      /* test component size against limit. */
         if (max_cpsiz > allw_cmpsiz)
         {
            err_typ = ERR_CHG;
            err_txt = psx->pnam;
         }

   if (ICh == 0)                        /* If eigenvalues were input, tests   */
      if (n_eigen != np)                /* against number of observed         */
         err_typ = ERR_EIP;             /* individuals.                       */

   if (np > allw_obsiz)                 /* Tests the number of observed       */
      err_typ = ERR_OBS;                /* individuals against the limit.     */

   /* We may need a test on component size here?                              */

   if (err_typ)
      if (proc_err ())
         return FALSE;

   return TRUE;
}
