/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#include "stuff.h"

double dist2rf (double distance)
{                                       /* converts distance in cM
                                         * to recombination fraction using
                                         * Haldane's formula                  */
   return .5 * (1. - exp (-2. * distance / 100.));
}

double rf2dist (double recomb_fract)
{                                       /* converts recombination fraction 
                                         * to distance in cM using
                                         * Haldane's formula                  */
   return -.5 * log (1. - 2. * recomb_fract) * 100.;
}

double distK2rf (double distKos)
{                                       /* converts distance in Kosambi cM
                                         * to recombination fraction          */
   double x;

   x = exp (4. * distKos / 100.);
   return .5 * ((x - 1.) / (x + 1.));
}

double rf2distK (double recomb_fract)
{                                       /* converts recombination fraction 
                                         * to Kosambi distance in cM          */
   return
      .25 * log ((1. + 2. * recomb_fract) / (1. - 2. * recomb_fract)) * 100.;
}
