/* functions are:  prnt_locnam(), fmt_locnamlin() */

#include "stuff.h"

/***
 * prints a list of locus names, given the index to the locus.
 * trait index is 0;  marker indices are 1, ...
 */
void prnt_locnam (int nn, int *loc)
{
   int   nc, i;

   nc = (LineWidth - 1) / (LocNamLen + 1);

   for (i = 0; i < nn; ++i)
   {
      if (!(i % nc))
         fprintf (stdout, "\n");
      if (loc[i] == 0)
         fprintf (stdout, "  %*s", LocNamLen, TraitNam[0]);
      else
         fprintf (stdout, "  %*s", LocNamLen, MarkNam[loc[i] - 1]);
   }
   fprintf (stdout, "\n\n");
   fflush (stdout);

   return;
}

/***
 * formats one line of locus names, given the index to the locus.
 * trait index is 0;  marker indices are 1, ...
 */
void fmt_locnamlin (char *lin, int *cur, int nn, int *loc)
{
   /* cur is the current locus, nn is the number of loci,
    * *loc is a list of locus indices.
    */
   int   ncol;
   int   i = 0;

   ncol = (LineWidth - 1) / (LocNamLen + 1);

   while (*cur < nn && i < ncol)
   {
      if (loc[*cur] == 0)
         sprintf (lin + i * (LocNamLen + 1), "  %*s", LocNamLen, TraitNam[0]);
      else
         sprintf (lin + i * (LocNamLen + 1), "  %*s", LocNamLen,
                  MarkNam[loc[*cur] - 1]);
      ++i;
      ++*cur;
   }
   return;
}
